//+------------------------------------------------------------------+
//|                                                        Bands.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  LightSeaGreen
#property indicator_color2  LightSeaGreen
#property indicator_color3  LightSeaGreen

//
//
//
//
//

extern string TimeFrame         = "current time frame";
extern int    BandsLength       = 20;
extern double BandsDeviation    = 2.0; 
extern int    AppliedPrice      = PRICE_CLOSE;
extern int    BandsMaMode       = MODE_EMA; 

extern bool   alertsOn          = true;
extern bool   alertsOnCurrent   = false;
extern bool   alertsOnBandBreak = true;
extern bool   alertsOnMaCross   = true;
extern bool   alertsMessage     = true;
extern bool   alertsSound       = false;
extern bool   alertsEmail       = false;

//
//
//
//
//

double Ma[];
double UpMa[];
double DnMa[];
double trend1[];
double trend2[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
  IndicatorBuffers(5);
   SetIndexBuffer(0,Ma);
   SetIndexBuffer(1,UpMa);
   SetIndexBuffer(2,DnMa);
   SetIndexBuffer(3,trend1);
   SetIndexBuffer(4,trend2);

      //
      //
      //
      //
      //
   
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame=="returnBars";     if (returnBars)     return(0);
      calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      
  IndicatorShortName(timeFrameToString(timeFrame)+"   bollinger bands ");    
return(0);
}

//
//
//
//
//

int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
  {
   int counted_bars=IndicatorCounted();
   int i,j,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-1,Bars-counted_bars-1);
           if (returnBars)  { Ma[0] = limit+1; return(0); }
           
   //
   //
   //
   //
   //
    
   if (calculateValue || timeFrame==Period())
   {       
     for (i = limit; i >= 0; i--)
     {
         double StdDev  = iStdDev(NULL,0,BandsLength,0,BandsMaMode,AppliedPrice,i); 
                Ma[i]   = iMA(NULL,0,BandsLength,0,BandsMaMode,AppliedPrice,i);
                UpMa[i] = Ma[i] + (StdDev*BandsDeviation);
                DnMa[i] = Ma[i] - (StdDev*BandsDeviation);
                trend1[i] = trend1[i+1]; 
                trend2[i] = trend2[i+1]; 
                   if(UpMa[i]<Ask)    trend1[i] = 1;
                   if(DnMa[i]>Bid)    trend1[i] =-1;
                   if(Ma[i]>Close[i]) trend2[i] = 1;
                   if(Ma[i]<Close[i]) trend2[i] =-1;
       }
       manageAlerts();         
   return(0);            
   }
   
   //
   //
   //
   //
   //
      
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         Ma[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsLength,BandsDeviation,AppliedPrice,BandsMaMode,0,y);
         UpMa[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsLength,BandsDeviation,AppliedPrice,BandsMaMode,1,y);
         DnMa[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BandsLength,BandsDeviation,AppliedPrice,BandsMaMode,2,y);
         trend1[i] = trend1[i+1]; 
         trend2[i] = trend2[i+1]; 
             if(UpMa[i]<Ask)    trend1[i] = 1;
             if(DnMa[i]>Bid)    trend1[i] =-1;
             if(Ma[i]>Close[i]) trend2[i] = 1;
             if(Ma[i]<Close[i]) trend2[i] =-1;
    }
    manageAlerts();         
return(0);            
}

//
//
//
//
//

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnBandBreak && trend1[whichBar] != trend1[whichBar+1])
         {
            if (trend1[whichBar] ==  1) doAlert(time1,mess1,whichBar," Price crossed upper band up");
            if (trend1[whichBar] == -1) doAlert(time1,mess1,whichBar," Price crossed lower band down");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnMaCross && trend2[whichBar] != trend2[whichBar+1])
         {
            if (trend2[whichBar] ==  1) doAlert(time2,mess2,whichBar," Price crossed ma up");
            if (trend2[whichBar] == -1) doAlert(time2,mess2,whichBar," Price crossed ma down");
         }            
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  Symbol()+" "+timeFrameToString(timeFrame)+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," BBands "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}



//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}   

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

